package enforcer.instr;

/* $Id: TestCTNestedAssertions.java 580 2007-05-30 03:07:12Z cartho $ */

import enforcer.rt.Coverage;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class TestCTNestedAssertions extends TestCase {
    private static int res = 2;

    public static void main(String[] args) {
        boolean result;
        enforcer.rt.Coverage.initialize();
        junit.textui.TestRunner.run(suite());
        result = enforcer.rt.Eval.reRunTests();
        assert (result); // nested test
    }

    public static Test suite() {
        return new TestSuite(TestCTNestedAssertions.class);
    }

    int assign(int i) throws Exception {
        return i;
    }

    public void testForceExc() { // exception that does not occur
        int i = 0;
        try {
            i = assign(1);
            try {
                i = assign(2);
            } catch (Exception e0) {
                i = 3;
            }
        } catch (Exception e1) {
            try {
                i = assign(4);
            } catch (Exception e2) {
                i = 5;
            }
        }
assert ((i == res) || (i == 4)) : "i != res : " + i + " != " + res;
        res += 2;
        if (res == 6) {
            res = 3;
        }
        // first test: normal, result (i) = 2
        // second test: forcing outer exc.: i = 4
        // third test: forcing upper inner exc.: i = 3
        // final test: nested exc.: i = 5
        //System.out.println("---> " + i);
    }
}
