package enforcer.instr;

/* $Id: TestExceptionCons.java 580 2007-05-30 03:07:12Z cartho $ */
/* Test exception type where no constructor (String) exists, but
   (Throwable, String) (one type of constructor with a String
   argument must exist) */

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

class MyException extends Exception {
    public MyException(String msg, Throwable t) {
        super(msg, t);
    }
}

public class TestExceptionCons extends TestCase {
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }

    public static Test suite() {
        return new TestSuite(TestExceptionCons.class);
    }

    private void thisIsDangerous() throws MyException {}

    public void testCustomExc() { // exception that does not occur
        int i = 0;
        try {
            i++;
            thisIsDangerous();
        } catch (MyException e) {
            i--;
        }
    }
}
